VERSION 5.00
Begin VB.UserControl HyperLblCtl 
   AutoRedraw      =   -1  'True
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   MouseIcon       =   "HyperLblCtl.ctx":0000
   MousePointer    =   99  'Custom
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   4320
      Top             =   3120
   End
   Begin VB.Label lblLabel 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Label1"
      ForeColor       =   &H00FF0000&
      Height          =   195
      Left            =   1320
      TabIndex        =   0
      Top             =   1200
      Width           =   480
   End
End
Attribute VB_Name = "HyperLblCtl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'
' MiniBrowser
' Written by Paul Kershaw 2002-2004
' Copyright (C) 2002, 2004
'
' This source file is part of MiniBrowser.
'
' MiniBrowser is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' Foobar is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with Foobar; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Event Click(ByVal sURL As String)
Public Event MouseOver()
Public Event MouseOut()

Private bMouseOver As Boolean
Private mcPoint As POINTAPI
Private mbLaunchURL As Boolean

Private Sub lblLabel_Change()
    CtlResize
End Sub

Private Sub lblLabel_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    With lblLabel
        If X >= 0 And Y >= 0 And _
           X <= .Width And Y <= .Height Then
            If Button = 1 Then
                If Len(lblLabel.Tag) Then
                    If mbLaunchURL Then
                        LaunchUrl lblLabel.Tag
                    End If
                    RaiseEvent Click(lblLabel.Tag)
                End If
            End If
        End If
    End With
End Sub

Private Sub Timer1_Timer()
    If hWndAtMouse = UserControl.hWnd Then
        If Not bMouseOver Then
            bMouseOver = True
            Call MouseOver_Proc
        End If
    Else
        If bMouseOver Then
            bMouseOver = False
            Call MouseOut_Proc
        End If
    End If
    DoEvents
End Sub

Private Sub UserControl_Initialize()
    bMouseOver = False
    CtlResize
End Sub

Public Sub CtlResize()
    With lblLabel
        If UserControl.Width <> lblLabel.Width Then UserControl.Width = lblLabel.Width
        If UserControl.Height <> lblLabel.Height Then UserControl.Height = lblLabel.Height
        If .Top <> 0 Then .Top = 0
        If .Left <> 0 Then .Left = 0
    End With
    DoEvents
End Sub

Private Sub UserControl_InitProperties()
    With lblLabel
        .Tag = ""
        .ToolTipText = ""
        .Caption = UserControl.Extender.Name
        lblLabel.ForeColor = vbBlue
        UserControl.BackColor = vbButtonFace
        mbLaunchURL = True
    End With
    CtlResize
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    With PropBag
        lblLabel.Tag = .ReadProperty("LINKURL", "")
        lblLabel.ToolTipText = lblLabel.Tag
        lblLabel.Caption = .ReadProperty("LABEL", UserControl.Extender.Name)
        lblLabel.ForeColor = .ReadProperty("LABELCOLOR", vbBlue)
        UserControl.BackColor = .ReadProperty("BACKCOLOR", vbButtonFace)
        mbLaunchURL = .ReadProperty("LAUNCHURL", True)
    End With
    Timer1.Enabled = Ambient.UserMode
End Sub

Private Sub UserControl_Resize()
    CtlResize
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        .WriteProperty "LINKURL", lblLabel.Tag
        .WriteProperty "LABEL", lblLabel.Caption
        .WriteProperty "LABELCOLOR", lblLabel.ForeColor
        .WriteProperty "BACKCOLOR", UserControl.BackColor
        .WriteProperty "LAUNCHURL", mbLaunchURL
    End With
End Sub

Public Function lngCursorX() As Long
    GetCursorPos mcPoint
    lngCursorX = mcPoint.X
End Function

Public Function lngCursorY() As Long
    GetCursorPos mcPoint
    lngCursorY = mcPoint.Y
End Function

Public Function hWndAtMouse() As Long
    hWndAtMouse = WindowFromPoint(lngCursorX, lngCursorY)
End Function

Public Sub MouseOver_Proc()
    With lblLabel
        If Not .FontUnderline Then
            .FontUnderline = True
            DoEvents
        End If
    End With
    RaiseEvent MouseOver
End Sub

Public Sub MouseOut_Proc()
    With lblLabel
        If .FontUnderline Then
            .FontUnderline = False
            DoEvents
        End If
    End With
    RaiseEvent MouseOut
End Sub

Public Property Get LinkURL() As String
    LinkURL = lblLabel.Tag
End Property

Public Property Let LinkURL(ByVal sNewValue As String)
    lblLabel.Tag = sNewValue
    lblLabel.ToolTipText = sNewValue
    UserControl.PropertyChanged "LINKURL"
End Property

Public Property Get Caption() As String
    Caption = lblLabel.Caption
End Property

Public Property Let Caption(ByVal sNewValue As String)
    lblLabel.Caption = sNewValue
    UserControl.PropertyChanged "LABEL"
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal ocNewValue As OLE_COLOR)
    UserControl.BackColor = ocNewValue
    UserControl.PropertyChanged "BACKCOLOR"
End Property

Public Property Get LabelColor() As OLE_COLOR
    LabelColor = lblLabel.ForeColor
End Property

Public Property Let LabelColor(ByVal ocNewValue As OLE_COLOR)
    lblLabel.ForeColor = ocNewValue
    UserControl.PropertyChanged "LABELCOLOR"
End Property

Public Sub LaunchUrl(ByVal strURL As String)
    ShellExecute UserControl.hWnd, _
                 vbNullString, _
                 strURL, _
                 vbNullString, _
                 vbNullString, _
                 1
    DoEvents
End Sub

Public Property Get Font() As IFontDisp
    
End Property

Public Property Let Font(ByVal ifdNewValue As IFontDisp)

End Property

Public Property Get LaunchUrlOn() As Boolean

    LaunchUrlOn = mbLaunchURL

End Property

Public Property Let LaunchUrlOn(ByVal bNewValue As Boolean)

    mbLaunchURL = bNewValue
    UserControl.PropertyChanged "LAUNCHURL"

End Property
