Attribute VB_Name = "MSysMenu32"
'
' MiniBrowser
' Written by Paul Kershaw 2002-2004
' Copyright (C) 2002, 2004
'
' This source file is part of MiniBrowser.
'
' MiniBrowser is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' Foobar is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with Foobar; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Public Declare Function CallWindowProc Lib "user32.dll" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function InsertMenuItem Lib "user32.dll" Alias "InsertMenuItemA" (ByVal hMenu As Long, ByVal uItem As Long, ByVal fByPosition As Long, lpmii As MENUITEMINFO) As Long
Public Declare Function SetMenuItemInfo Lib "user32.dll" Alias "SetMenuItemInfoA" (ByVal hMenu As Long, ByVal uItem As Long, ByVal fByPosition As Long, lpmii As MENUITEMINFO) As Long
Public Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function GetSystemMenu Lib "user32.dll" (ByVal hWnd As Long, ByVal bRevert As Long) As Long
Public Declare Function GetMenuItemCount Lib "user32.dll" (ByVal hMenu As Long) As Long
Public Declare Function SetMenuDefaultItem Lib "user32" (ByVal hMenu As Long, ByVal uItem As Long, ByVal fByPos As Long) As Long

Public Type MENUITEMINFO
    cbSize As Long
    fMask As Long
    fType As Long
    fState As Long
    wID As Long
    hSubMenu As Long
    hbmpChecked As Long
    hbmpUnchecked As Long
    dwItemData As Long
    dwTypeData As String
    cch As Long
End Type

Public Const MIIM_STATE = &H1
Public Const MIIM_ID = &H2
Public Const MIIM_TYPE = &H10
Public Const MFT_SEPARATOR = &H800
Public Const MFT_STRING = &H0
Public Const MFS_ENABLED = &H0
Public Const MFS_CHECKED = &H8
Public Const GWL_WNDPROC = -4
Public Const WM_SYSCOMMAND = &H112
Public Const WM_INITMENU = &H116

Public pOldProc As Long

Public Function WindowProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim hSysMenu As Long
    Dim MII As MENUITEMINFO
    Dim retval As Long
    
    Select Case uMsg
    Case WM_SYSCOMMAND
        If wParam = 1 Then
                        
            ''about
            'MsgBox "MiniBrowser written by Paul Kershaw", vbInformation, "About MiniBrowser"
            frmAbout.Show vbModal, frmMain
            
            WindowProc = 0
        ElseIf wParam = 2 Then
            ''options
            frmOptions.Init
            frmOptions.Show vbModeal, frmMain
        Else
            WindowProc = CallWindowProc(pOldProc, hWnd, uMsg, wParam, lParam)
        End If
    Case Else
        WindowProc = CallWindowProc(pOldProc, hWnd, uMsg, wParam, lParam)
    End Select
End Function

Public Sub AddSysMenuItem(lhWnd As Long, sItem As String)
    Dim hSysMenu As Long
    Dim count As Long
    Dim MII As MENUITEMINFO
    Dim retval As Long
    
    hSysMenu = GetSystemMenu(lhWnd, 0)
    count = GetMenuItemCount(hSysMenu)
    
    ''separator menu item
    With MII
        .cbSize = Len(MII)
        .fMask = MIIM_ID Or MIIM_TYPE
        .fType = MFT_SEPARATOR
        .wID = 0
    End With
    
    retval = InsertMenuItem(hSysMenu, count, 1, MII)
    
'' QUICK FIX!!!
    With MII
        .fMask = MIIM_STATE Or MIIM_ID Or MIIM_TYPE
        .fType = MFT_STRING
        .fState = MFS_ENABLED
        .wID = 2
        .dwTypeData = "MiniBrowser Options..."
        .cch = Len(.dwTypeData)
    End With
    
    retval = InsertMenuItem(hSysMenu, count + 1, 1, MII)
    
    ''about menu item
    With MII
        .fMask = MIIM_STATE Or MIIM_ID Or MIIM_TYPE
        .fType = MFT_STRING
        .fState = MFS_ENABLED
        .wID = 1
        .dwTypeData = sItem
        .cch = Len(.dwTypeData)
    End With
    
    retval = InsertMenuItem(hSysMenu, count + 2, 1, MII)

'    Call SetMenuDefaultItem(hSysMenu, 1, count + 2)

    pOldProc = SetWindowLong(lhWnd, GWL_WNDPROC, AddressOf WindowProc)
End Sub

Public Sub RemoveSysMenuItem(lhWnd As Long)
    Call SetWindowLong(lhWnd, GWL_WNDPROC, pOldProc)
    Call GetSystemMenu(lhWnd, 1)
End Sub
