Attribute VB_Name = "MWin32"
'
' MiniBrowser
' Written by Paul Kershaw 2002-2004
' Copyright (C) 2002, 2004
'
' This source file is part of MiniBrowser.
'
' MiniBrowser is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' Foobar is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with Foobar; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Const ThisModule = "MWin32"

Const HWND_TOPMOST = -1
Const HWND_NOTOPMOST = -2
Const SWP_NOSIZE = &H1
Const SWP_NOMOVE = &H2
Const SWP_NOACTIVATE = &H10
Const SWP_SHOWWINDOW = &H40

Const SHACF_DEFAULT  As Long = &H0

Global Const FavoritesBar = "{EFA24E61-B078-11D0-89E4-00C04FC9E26E}"

Public Const gs_RELEASE = "a"

Public Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Public Type DllVersionInfo
   cbSize As Long
   dwMajorVersion As Long
   dwMinorVersion As Long
   dwBuildNumber As Long
   dwPlatformID As Long
End Type

'/*
' * Window information snapshot
' */
Public Type WINDOWINFO
    cbSize As Long
    rcWindow As RECT
    rcClient As RECT
    dwStyle As Long
    dwExStyle As Long
    dwOtherStuff As Long
    cxWindowBorders As Long
    cyWindowBorders As Long
    atomWindowType As Integer
    wCreatorVersion As Integer
End Type

Public Declare Sub SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
Public Declare Function CreateRoundRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long) As Long
Public Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Public Declare Function FrameRgn Lib "gdi32" (ByVal hdc As Long, ByVal hRgn As Long, ByVal hBrush As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function GetDesktopWindow Lib "user32" () As Long
Public Declare Function GetWindowDC Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function SHAutoComplete Lib "shlwapi.dll" (ByVal hwndEdit As Long, ByVal dwFlags As Long) As Long
Public Declare Function DllGetVersion Lib "shlwapi.dll" (dwVersion As DllVersionInfo) As Long
Public Declare Function PathIsURL Lib "shlwapi.dll" Alias "PathIsURLA" (ByVal pszPath As String) As Long
Public Declare Function URLDownloadToFile Lib "urlmon" Alias "URLDownloadToFileA" (ByVal pCaller As Long, ByVal szURL As String, ByVal szFileName As String, ByVal dwReserved As Long, ByVal lpfnCB As Long) As Long
Public Declare Function GetWindowInfo Lib "user32.dll" (ByVal hWnd As Long, ByRef pwi As WINDOWINFO) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetLayeredWindowAttributes Lib "user32" (ByVal hWnd As Long, ByVal crKey As Long, ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long

Public gbVersionChecked As Boolean

Public Sub MakeAutoComplete(ByRef txtBOXhWnd)
    If IEVersion >= 5 Then
        ''ok to hook AutoComplete...
        Call SHAutoComplete(txtBOXhWnd, SHACF_DEFAULT)
    End If
End Sub

Public Sub FormMakeTopmost(fForm As Form)
    SetWindowPos fForm.hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE
End Sub

Public Function sAppVersion() As String
    With App
        sAppVersion = .Major & "." & .Minor & "." & .Revision & gs_RELEASE
    End With
End Function

Public Function sEXEBuildDate() As String
    With App
        sEXEBuildDate = Format$(FileDateTime(IIf(Right$(.Path, 1) <> "\", .Path & "\", .Path) & _
                     .EXEName & ".exe"), "dd-mmm-yyyy")
    End With
End Function

Public Function IEVersion() As Long

    Dim VersionInfo As DllVersionInfo
    VersionInfo.cbSize = Len(VersionInfo)
    
    Call DllGetVersion(VersionInfo)
    
    IEVersion = VersionInfo.dwMajorVersion

End Function

Public Function IEVersionString()

    Dim VersionInfo As DllVersionInfo
    VersionInfo.cbSize = Len(VersionInfo)
    
    Call DllGetVersion(VersionInfo)
    
'    IEVersionString = "Internet Explorer " & _
'        VersionInfo.dwMajorVersion & "." & _
'        VersionInfo.dwMinorVersion & "." & _
'        VersionInfo.dwBuildNumber
    
    IEVersionString = VersionInfo.dwMajorVersion & "." & _
        VersionInfo.dwMinorVersion & "." & _
        VersionInfo.dwBuildNumber

End Function

Public Function RemoteVersionCheck(ByVal sURL As String) As String
    If URLDownloadToFile(0, sURL, sAppPath & "LOCAL.VER", 0, 0) = 0 Then
        '' success!!
        
        Dim hFile As Long
        Dim sVersion As String
        
        hFile = FreeFile
        Open sAppPath & "LOCAL.VER" For Input As #hFile
            Line Input #hFile, sVersion
            sVersion = Trim$(sVersion)
        Close #hFile
        
        If LCase$(sVersion) = LCase$(sAppVersion) Then
            '' most up to date version installed
            RemoteVersionCheck = ""
        Else
            RemoteVersionCheck = sVersion
        End If
    End If
End Function

Public Function sAppPath() As String
    sAppPath = App.Path
    If Right$(sAppPath, 1) <> "\" Then
        sAppPath = sAppPath & "\"
    End If
End Function
