VERSION 5.00
Begin VB.UserControl SoftButton 
   AutoRedraw      =   -1  'True
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "SoftButton.ctx":0000
   Begin VB.Timer tmrMouseMonitor 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   1920
      Top             =   3120
   End
   Begin VB.Label Cover 
      BackStyle       =   0  'Transparent
      Height          =   1215
      Left            =   720
      TabIndex        =   1
      Top             =   1080
      Width           =   2055
   End
   Begin VB.Label lblCaption 
      Alignment       =   2  'Center
      BackColor       =   &H0080FF80&
      BackStyle       =   0  'Transparent
      Caption         =   "XXXXXX"
      ForeColor       =   &H80000010&
      Height          =   190
      Left            =   240
      TabIndex        =   0
      Top             =   1200
      Width           =   4335
   End
   Begin VB.Image Image1 
      Height          =   495
      Left            =   40
      Top             =   40
      Width           =   375
   End
End
Attribute VB_Name = "SoftButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'
' MiniBrowser
' Written by Paul Kershaw 2002-2004
' Copyright (C) 2002, 2004
'
' This source file is part of MiniBrowser.
'
' MiniBrowser is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' Foobar is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with Foobar; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function DrawFocusRect Lib "user32" (ByVal hdc As Long, lpRect As RECT) As Long

''border colors
Const lBorderLightStyle = &HE0E0E0
Const lBorderDarkStyle = &H808080
Const lBorderLightNormal = &HE0E0E0
Const lBorderDarkNormal = &H808080
Const lBorderOverDark = &H0
Const lBorderOverLight = &HFFFFFF

''display
Const lBorderCut = 10
Const lCaptionCut = 20
Const lFocusRectOffset = 3

Enum BorderType
    btNormal = 0
    btLight = 1
    btDark = 2
End Enum

Dim bMouseTracking As Boolean       ''mouse tracking option enabled/disabled
Dim bMouseDown As Boolean           ''is mouse button currently down?
Dim bMouseDownDrawn As Boolean      ''have the borders been draw to show above?
Dim bMouseOver As Boolean           ''is the mouse over the control?
Dim bIsEnabled As Boolean           ''is the control enabled
Dim btBorder As BorderType          ''the current border style
Private m_bHasFocus As Boolean
Dim udtCursorPos As POINTAPI
Dim bFlag As Boolean
Dim mForeColor As OLE_COLOR

Dim pPictureCold As Picture
Dim pPictureHot As Picture

Public Event Click()
Public Event MouseOver()
Public Event MouseOut()

Private Sub tmrMouseMonitor_Timer()
    ''keeps track of the position of the mouse-cursor

    If bIsEnabled Then
        Dim lhWnd As Long
        
        If bFlag = False Then
            bFlag = True
        End If
        
        GetCursorPos udtCursorPos
        lhWnd = WindowFromPoint(udtCursorPos.x, _
                                udtCursorPos.y)
        
        If lhWnd = UserControl.hWnd Then
            If Not bMouseOver Then
                bMouseOver = True
                ''
                ''mouse has just entered the control
                ''
            
                ''raise the mouseover event
                RaiseEvent MouseOver
            
                DrawPicture True
                DrawBordersOver bMouseDown
            End If
        Else
            If bMouseOver Then
                bMouseOver = False
                ''
                ''mouse has just left the control
                ''
            
                ''raise the mouseout event
                RaiseEvent MouseOut
            
                DrawPicture False
                DrawBorders False
            End If
        End If
    Else
        If bFlag Then
            DrawBorders False
            bFlag = False
        End If
    End If
End Sub

Private Sub UserControl_GotFocus()

    m_bHasFocus = True
    If bIsEnabled Then
        DrawFocusRect UserControl.hdc, GetCtlRect()
    End If

End Sub

Private Sub UserControl_Initialize()
    bMouseDown = False
    bMouseOver = False
    m_bHasFocus = False
End Sub

Private Sub Cover_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    
    If bIsEnabled And Button = 1 Then
        ''let the rest of the control know that the mouse is down
        ''and draw borders
        bMouseDown = True
        bMouseDownDrawn = False
        DrawBordersOver True
    End If
End Sub

Private Sub Cover_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    If bMouseDown Then
        With UserControl
            If x >= 0 And x <= .Width And y >= 0 And y <= .Height Then
                If Not bMouseDownDrawn Then
                    DrawBordersOver True
                    bMouseDownDrawn = True
                End If
            Else
                If bMouseDownDrawn Then
                    DrawBorders False
                    bMouseDownDrawn = False
                End If
            End If
        End With
    End If
End Sub

Private Sub Cover_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If bIsEnabled Then
        bMouseDown = False
        'DrawBordersOver False
    
        If x >= 0 And x <= UserControl.Width And y >= 0 And y <= UserControl.Height Then
            DrawBordersOver False
            If Button = 1 Then
                ''mouse button was released over the control
                RaiseEvent Click
                If bMouseTracking = False Then
                    DrawBorders False
                End If
            End If
        Else
            DrawBorders False
        End If
    End If
End Sub

Private Sub UserControl_InitProperties()
    Cover.ToolTipText = ""
    lblCaption.Caption = UserControl.Extender.Name
    lblCaption.ForeColor = vbButtonText
    UserControl.BackColor = vbButtonFace
    btBorder = btNormal
    bIsEnabled = True
    bMouseTracking = False
End Sub

Private Sub UserControl_LostFocus()
    m_bHasFocus = False
    UserControl.Cls
    DrawBorders bMouseDown
    DrawPicture False
    ResizeCaption
    ResizeCover
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    With PropBag
        Cover.ToolTipText = .ReadProperty("TOOLTIP", "")
        mForeColor = .ReadProperty("ForeColor", vbButtonText)
        lblCaption.Caption = .ReadProperty("CAPTION", UserControl.Extender.Name)
        bIsEnabled = CBool(.ReadProperty("ENABLED", "True"))
        btBorder = CInt(.ReadProperty("BORDER", 0))
        UserControl.BackColor = .ReadProperty("BACKCOLOR", vbButtonFace)
        bMouseTracking = .ReadProperty("MOUSETRACKING", True)
        Set pPictureCold = .ReadProperty("PictureCold", Image1.Picture)
        Set pPictureHot = .ReadProperty("PictureHot", Image1.Picture)
        
        If bIsEnabled Then
            lblCaption.ForeColor = mForeColor
        Else
            lblCaption.ForeColor = vbButtonShadow
        End If
        
        DrawPicture False
        DrawBorders False
    End With
    
    '' mouse tracking set up
    If Not Ambient.UserMode Then
        '' we are in design mode, so
        '' we definitely DO NOT want
        '' mouse tracking!!
        tmrMouseMonitor.Enabled = False
    Else
        tmrMouseMonitor.Enabled = bMouseTracking
    End If
    
    DoEvents
End Sub

Private Sub UserControl_Resize()
    UserControl.Cls
    DrawBorders bMouseDown
    ResizeCaption
    ResizeCover
End Sub

Public Sub DrawBorders(bPressed As Boolean)
    ''controls the appearance of the control
    
    With UserControl
        
        If bPressed Then
            Line (0, 0)-(0, (.Height - lBorderCut)), lBorderDarkNormal
            Line (0, 0)-((.Width - lBorderCut), 0), lBorderDarkNormal
            
            Line (0, (.Height - lBorderCut))-((.Width - lBorderCut), (.Height - lBorderCut)), lBorderLightNormal
            Line ((.Width - lBorderCut), 0)-((.Width - lBorderCut), .Height), lBorderLightNormal ''does not use border cut
                                                                                           ''because covers up corner
                                                                                           ''space
        Else
            Select Case btBorder
                Case 0 ''normal
                    lBorderLight = lBorderLightNormal
                    lBorderDark = lBorderDarkNormal
                Case 1 ''light
                    lBorderLight = lBorderLightStyle
                    lBorderDark = lBorderLightStyle
               Case 2 ''dark
                    lBorderLight = lBorderDarkStyle
                    lBorderDark = lBorderDarkStyle
               Case Else ''fuck up
                    MsgBox "SoftTextCtl::DrawBorders()" & vbNewLine & vbNewLine & _
                           "Invalid value for 'btBorder' border type!", vbExclamation, _
                           "Ooooops!"
            End Select
            
            Line (0, 0)-(0, (.Height - lBorderCut)), lBorderLight
            Line (0, 0)-((.Width - lBorderCut), 0), lBorderLight
            
            Line (0, (.Height - lBorderCut))-((.Width - lBorderCut), (.Height - lBorderCut)), lBorderDark
            Line ((.Width - lBorderCut), 0)-((.Width - lBorderCut), .Height), lBorderDark ''does not use border cut
                                                                                          ''because covers up corner
                                                                                          ''space
        End If
        
        DoEvents
    End With
End Sub

Public Sub DrawBordersOver(bPressed As Boolean)
    ''controls the appearance of the control
    With UserControl
        
        If bPressed Then
            Line (0, 0)-(0, (.Height - lBorderCut)), lBorderOverDark
            Line (0, 0)-((.Width - lBorderCut), 0), lBorderOverDark
            
            Line (0, (.Height - lBorderCut))-((.Width - lBorderCut), (.Height - lBorderCut)), lBorderOverLight
            Line ((.Width - lBorderCut), 0)-((.Width - lBorderCut), .Height), lBorderOverLight ''does not use border cut
                                                                                               ''because covers up corner
                                                                                               ''space
        Else
            Line (0, 0)-(0, (.Height - lBorderCut)), lBorderOverLight
            Line (0, 0)-((.Width - lBorderCut), 0), lBorderOverLight
            
            Line (0, (.Height - lBorderCut))-((.Width - lBorderCut), (.Height - lBorderCut)), lBorderOverDark
            Line ((.Width - lBorderCut), 0)-((.Width - lBorderCut), .Height), lBorderOverDark ''does not use border cut
                                                                                              ''because covers up corner
                                                                                              ''space
        End If
        
        DoEvents
    End With
End Sub

Public Property Get Caption() As String
    Caption = lblCaption.Caption
End Property

Public Property Let Caption(ByVal sNewValue As String)
    lblCaption.Caption = sNewValue
End Property

Public Sub ResizeCaption()
    With lblCaption
        .Left = lCaptionCut
        .Width = UserControl.Width - lCaptionCut
        
        .Top = CLng((UserControl.Height / 2) - (.Height / 2))
'        .Top = Image1.Top + Image1.Height
    End With
    DoEvents
End Sub

Public Sub ResizeCover()
    With Cover
        .Left = 0
        .Top = 0
        .Width = UserControl.Width
        .Height = UserControl.Height
        DoEvents
    End With
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        Call .WriteProperty("TOOLTIP", Cover.ToolTipText, "")
        Call .WriteProperty("ForeColor", mForeColor, vbButtonText)
        Call .WriteProperty("CAPTION", lblCaption.Caption)
        Call .WriteProperty("ENABLED", bIsEnabled)
        Call .WriteProperty("BORDER", btBorder)
        Call .WriteProperty("BACKCOLOR", UserControl.BackColor)
        Call .WriteProperty("PictureCold", pPictureCold, Nothing)
        Call .WriteProperty("PictureHot", pPictureHot, Nothing)
        Call .WriteProperty("MOUSETRACKING", bMouseTracking, True)
    End With
End Sub

Public Property Get Enabled() As Boolean
    Enabled = bIsEnabled
End Property

Public Property Let Enabled(ByVal vNewValue As Boolean)
    bIsEnabled = vNewValue
    If bIsEnabled Then
        lblCaption.ForeColor = mForeColor
        If m_bHasFocus Then
            UserControl_GotFocus
        End If
    Else
        lblCaption.ForeColor = vbButtonShadow
        UserControl_LostFocus
    End If
    DoEvents
End Property

Public Property Get BorderStyle() As BorderType
    BorderStyle = btBorder
End Property

Public Property Let BorderStyle(ByVal btNewValue As BorderType)
    btBorder = btNewValue
    DrawBorders False
End Property

Public Property Get hWnd() As Long
    hWnd = UserControl.hWnd
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal ocNewValue As OLE_COLOR)
    UserControl.BackColor = ocNewValue
    UserControl.PropertyChanged "BACKCOLOR"
    DrawBorders False
End Property

Public Property Get PictureCold() As Picture
    Set PictureCold = pPictureCold
End Property

Public Property Set PictureCold(ByVal New_Picture As Picture)
    Set pPictureCold = New_Picture
    PropertyChanged "PictureCold"
    DrawPicture False
End Property

Public Property Get PictureHot() As Picture
    Set PictureHot = pPictureHot
End Property

Public Property Set PictureHot(ByVal New_Picture As Picture)
    Set pPictureHot = New_Picture
    PropertyChanged "PictureHot"
    DrawPicture False
End Property

Public Property Get ForeColor() As OLE_COLOR
    ForeColor = mForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    mForeColor = New_ForeColor
    If bIsEnabled Then
        lblCaption.ForeColor = mForeColor
    Else
        lblCaption.ForeColor = vbButtonFace
    End If
    PropertyChanged "ForeColor"
End Property

Public Sub DrawPicture(ByVal bOver As Boolean)
    On Error Resume Next
    If bOver Then
        If Image1.Picture <> pPictureHot Then
            Set Image1.Picture = pPictureHot
        End If
    Else
        If Image1.Picture <> pPictureCold Then
            Set Image1.Picture = pPictureCold
        End If
    End If
End Sub

Public Property Get ToolTipText() As String
    ToolTipText = Cover.ToolTipText
End Property

Public Property Let ToolTipText(ByVal sString As String)
    Cover.ToolTipText = sString
    UserControl.PropertyChanged "TOOLTIP"
End Property

Public Property Get MouseTracking() As Boolean
    MouseTracking = bMouseTracking
End Property

Public Property Let MouseTracking(ByVal bNewValue As Boolean)
    bMouseTracking = bNewValue
    If Ambient.UserMode Then
        tmrMouseMonitor.Enabled = bMouseTracking
    Else
        tmrMouseMonitor.Enabled = False
    End If
End Property

Private Function GetCtlRect() As RECT
    
    With GetCtlRect
        .Left = lFocusRectOffset
        .Top = lFocusRectOffset
        .Right = (UserControl.Width / Screen.TwipsPerPixelX) - lFocusRectOffset
        .Bottom = (UserControl.Height / Screen.TwipsPerPixelY) - lFocusRectOffset
    End With
    
End Function
