VERSION 5.00
Begin VB.UserControl SoftText 
   AutoRedraw      =   -1  'True
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5925
   DefaultCancel   =   -1  'True
   KeyPreview      =   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   5925
   ToolboxBitmap   =   "SoftText.ctx":0000
   Begin VB.Timer tmrMouseMonitor 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   1560
      Top             =   3000
   End
   Begin VB.TextBox txtText 
      Appearance      =   0  'Flat
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   245
      Left            =   1320
      TabIndex        =   0
      Top             =   1920
      Width           =   3045
   End
End
Attribute VB_Name = "SoftText"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'
' MiniBrowser
' Written by Paul Kershaw 2002-2004
' Copyright (C) 2002, 2004
'
' This source file is part of MiniBrowser.
'
' MiniBrowser is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' Foobar is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with Foobar; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Const lLightCol = &HE0E0E0
Const lDarkCol = &H808080
Const lLightColOver = &HFFFFFF
Const lDarkColOver = &H0

Enum TextAlignment
    tLeft = 0
    tRight = 1
    tCenter = 2
End Enum

Public Event KeyPress(KeyAscii As Integer)
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Public Event Change()
Public Event Click()
Public Event DblClick()
Public Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

Dim bMouseTracking As Boolean       ''mouse tracking option enabled/disabled
Dim bMouseOver As Boolean
Dim bGotFocus As Boolean
Dim bEnabled As Boolean
Dim udtPointXY As POINTAPI

Public Sub ResizeText()
    With txtText
        .Left = 15
        .Top = 10
'        UserControl.Height = .Height + 20
'        .Width = UserControl.Width - 25
        UserControl.Height = .Height + 40
        .Width = UserControl.Width - 50
        DoEvents
    End With
    DrawBorders
End Sub

Private Sub tmrMouseMonitor_Timer()
    On Error GoTo e
    
    Dim lhWnd As Long
    
    lhWnd = WindowFromPoint(CursorX, _
                            CursorY)
    
    If bEnabled Then
        If lhWnd = txtText.hWnd Then
            If Not bMouseOver Then
                bMouseOver = True
                ''fire mouseover event here
                DrawBorders
            End If
        Else
            If bMouseOver Then
                bMouseOver = False
                ''fire mouseout event here
                DrawBorders
            End If
        End If
    End If
    Exit Sub
e:
    MsgBox "SoftText::tmrMouseMonitor_Timer()" & vbNewLine & Error(Err) & Err
End Sub

Private Sub txtText_Change()
    RaiseEvent Change
End Sub

Private Sub txtText_Click()
    RaiseEvent Click
End Sub

Private Sub txtText_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub txtText_GotFocus()
    bGotFocus = True
    DrawBorders
End Sub

Private Sub txtText_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub txtText_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub txtText_LostFocus()
    bGotFocus = False
    DrawBorders
End Sub

Private Sub txtText_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub txtText_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub txtText_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub UserControl_Initialize()
    bMouseOver = False
    bGotFocus = False
End Sub

Private Sub UserControl_InitProperties()
    txtText.BackColor = vbHighlightText
    bEnabled = True
    bMouseTracking = False
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    With txtText
        .Text = PropBag.ReadProperty("tTEXT", UserControl.Extender.Name)
        .Locked = PropBag.ReadProperty("tLOCKED", False)
        .Alignment = PropBag.ReadProperty("tALIGNMENT", 0)
        .MaxLength = PropBag.ReadProperty("tMAXLENGTH", 0)
        .BackColor = PropBag.ReadProperty("tBACKCOLOR", vbWindowBackground)
        bEnabled = PropBag.ReadProperty("tENABLED", True)
        bMouseTracking = PropBag.ReadProperty("MOUSETRACKING", True)
    End With
    
    '' mouse tracking set up
    If Not Ambient.UserMode Then
        '' we are in design mode, so
        '' we definitely DO NOT want
        '' mouse tracking!!
        tmrMouseMonitor.Enabled = False
    Else
        tmrMouseMonitor.Enabled = bMouseTracking
    End If
End Sub

Private Sub UserControl_Resize()
    ResizeText
End Sub

Public Property Get Text() As String
    Text = txtText.Text
End Property

Public Property Let Text(ByVal sNewValue As String)
    txtText.Text = sNewValue
End Property

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With txtText
        Call PropBag.WriteProperty("tTEXT", .Text)
        Call PropBag.WriteProperty("tLOCKED", .Locked)
        Call PropBag.WriteProperty("tALIGNMENT", .Alignment)
        Call PropBag.WriteProperty("tMAXLENGTH", .MaxLength)
        Call PropBag.WriteProperty("tBACKCOLOR", .BackColor)
        Call PropBag.WriteProperty("tENABLED", bEnabled)
        Call PropBag.WriteProperty("MOUSETRACKING", bMouseTracking, True)
    End With
End Sub

Public Property Get Locked() As Boolean
    Locked = txtText.Locked
End Property

Public Property Let Locked(ByVal bNewValue As Boolean)
    txtText.Locked = bNewValue
End Property

Public Property Get Alignment() As TextAlignment
    Alignment = txtText.Alignment
End Property

Public Property Let Alignment(ByVal iNewValue As TextAlignment)
    txtText.Alignment = iNewValue
End Property

Public Property Get SelStart() As Long
    SelStart = txtText.SelStart
End Property

Public Property Let SelStart(ByVal lNewValue As Long)
    txtText.SelStart = lNewValue
End Property

Public Property Get SelLength() As Long
    SelLength = txtText.SelLength
End Property

Public Property Let SelLength(ByVal lNewValue As Long)
    txtText.SelLength = lNewValue
End Property

Public Property Get MaxLength() As Long
    MaxLength = txtText.MaxLength
End Property

Public Property Let MaxLength(ByVal lNewValue As Long)
    txtText.MaxLength = lNewValue
End Property

Public Sub DrawBorders()
    If bMouseOver = True Or bGotFocus = True Then
        Line (0, 0)-(0, UserControl.Height), lDarkColOver
        
        Line (0, UserControl.Height - 20)-(UserControl.Width, UserControl.Height - 20), vbButtonFace
        Line (UserControl.Width - 20, 0)-(UserControl.Width - 20, UserControl.Height), vbButtonFace
        
        Line (0, UserControl.Height - 10)-(UserControl.Width, UserControl.Height - 10), lLightColOver
        Line (UserControl.Width - 10, 0)-(UserControl.Width - 10, UserControl.Height), lLightColOver
        
        Line (0, 0)-(UserControl.Width - 10, 0), lDarkColOver
    Else
        Line (0, 0)-(0, UserControl.Height), lDarkCol
        
        Line (0, UserControl.Height - 20)-(UserControl.Width, UserControl.Height - 20), vbButtonFace
        Line (UserControl.Width - 20, 0)-(UserControl.Width - 20, UserControl.Height), vbButtonFace
        
        Line (0, UserControl.Height - 10)-(UserControl.Width, UserControl.Height - 10), lLightCol
        Line (UserControl.Width - 10, 0)-(UserControl.Width - 10, UserControl.Height), lLightCol
        
        Line (0, 0)-(UserControl.Width - 10, 0), lDarkCol
    End If
    
    DoEvents
End Sub

Public Property Get TextBox_hWnd() As Long
    TextBox_hWnd = txtText.hWnd
End Property

Public Function CursorX() As Long
    GetCursorPos udtPointXY
    CursorX = udtPointXY.X
End Function

Public Function CursorY() As Long
    GetCursorPos udtPointXY
    CursorY = udtPointXY.Y
End Function

Public Property Get BackColor() As OLE_COLOR
    BackColor = txtText.BackColor
End Property

Public Property Let BackColor(ByVal ocNewValue As OLE_COLOR)
    txtText.BackColor = ocNewValue
    UserControl.PropertyChanged "tBACKCOLOR"
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property

Public Property Let Enabled(ByVal bNewValue As Boolean)
    bEnabled = bNewValue
    txtText.Enabled = bNewValue
    UserControl.PropertyChanged "tENABLED"
End Property

Public Property Get MouseTracking() As Boolean
    MouseTracking = bMouseTracking
End Property

Public Property Let MouseTracking(ByVal bNewValue As Boolean)
    bMouseTracking = bNewValue
    If Ambient.UserMode Then
        tmrMouseMonitor.Enabled = bMouseTracking
    Else
        tmrMouseMonitor.Enabled = False
    End If
End Property


