Attribute VB_Name = "mdlGlobals"
'
' MiniBrowser
' Written by Paul Kershaw 2002-2004
' Copyright (C) 2002, 2004
'
' This source file is part of MiniBrowser.
'
' MiniBrowser is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' Foobar is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with Foobar; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Option Explicit

Public Const gsAppName = "MiniBrowser"
Public Const gsRegKey = "Prefs"
Public Const gsKeyDefaultHomepage = "Default Homepage"
Public Const gsKeyDefaultSearchPage = "Default SearchPage"
Public Const gsKeyShowToolbar = "Show Toolbar"
Public Const gsKeyWindowOpacity = "Window Opacity"

Public gsDefaultHomepage As String
Public gsDefaultSearchPage As String
Public gbShowToolbar As Boolean
Public glWindowOpacity As Long

Public Function gsGetDefaultHomepage() As String
    gsGetDefaultHomepage = GetSetting(gsAppName, gsRegKey, gsKeyDefaultHomepage, "")
End Function

Public Sub gSetDefaultHomepage(ByVal sURL As String)
    SaveSetting gsAppName, gsRegKey, gsKeyDefaultHomepage, sURL
End Sub

Public Function gbGetShowToolbar() As Boolean
    gbGetShowToolbar = CBool(GetSetting(gsAppName, gsRegKey, gsKeyShowToolbar, "True"))
End Function

Public Sub gSetShowToolbar(ByVal bValue As Boolean)
    SaveSetting gsAppName, gsRegKey, gsKeyShowToolbar, bValue
End Sub

Public Sub LoadPrefs()
    gsDefaultHomepage = gsGetDefaultHomepage
    gsDefaultSearchPage = gsGetDefaultSearchPage
    gbShowToolbar = gbGetShowToolbar
    glWindowOpacity = glGetWindowOpacity()
End Sub

Public Sub SavePrefs()
    gSetDefaultHomepage gsDefaultHomepage
    gSetDefaultSearchPage gsDefaultSearchPage
    gSetShowToolbar gbShowToolbar
    gSetWindowOpacity glWindowOpacity
End Sub

Public Function gsGetDefaultSearchPage() As String
    gsGetDefaultSearchPage = GetSetting(gsAppName, gsRegKey, gsKeyDefaultSearchPage, "")
End Function

Public Sub gSetDefaultSearchPage(ByVal sURL As String)
    SaveSetting gsAppName, gsRegKey, gsKeyDefaultSearchPage, sURL
End Sub

Public Function glGetWindowOpacity() As Long
    glGetWindowOpacity = CLng(GetSetting(gsAppName, gsRegKey, gsKeyWindowOpacity, 100))
End Function

Public Sub gSetWindowOpacity(ByVal lWindowOpacity As Long)
    SaveSetting gsAppName, gsRegKey, gsKeyWindowOpacity, lWindowOpacity
End Sub

Public Sub SetAllWindowOpacities()

    Dim I As Long
    For I = 0 To Forms.count - 1
        SetWindowOpacity Forms(I).hWnd, glWindowOpacity
    Next I

End Sub
