Attribute VB_Name = "mdlWinOpacity"
'
' MiniBrowser
' Written by Paul Kershaw 2002-2004
' Copyright (C) 2002, 2004
'
' This source file is part of MiniBrowser.
'
' MiniBrowser is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' Foobar is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with Foobar; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Option Explicit

Private Const LWA_COLORKEY = &H1
Private Const LWA_ALPHA = &H2
Private Const GWL_EXSTYLE = (-20)
Private Const WS_EX_LAYERED = &H80000
Private Const RequiredVersion As Long = 5

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetLayeredWindowAttributes Lib "user32" (ByVal hWnd As Long, ByVal crKey As Long, ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long
Private Declare Function OSVersion Lib "kernel32" Alias "GetVersion" () As Long

Public Sub SetWindowOpacity(ByVal hWnd As Long, ByVal bytePercentOpacity As Byte)

    If WindowsIsSuitableForLayers() Then

        Dim Ret As Long
        Dim lOpacity As Long
        
        lOpacity = CInt((bytePercentOpacity / 100) * 255)
        
        If lOpacity = 255 Then
    '        Debug.Print "OFF"
            SetWindowLong hWnd, GWL_EXSTYLE, GetWindowLong(hWnd, GWL_EXSTYLE) And Not WS_EX_LAYERED
        Else
            'Set the window style to 'Layered'
            
            Ret = GetWindowLong(hWnd, GWL_EXSTYLE)
            Ret = Ret Or WS_EX_LAYERED
            SetWindowLong hWnd, GWL_EXSTYLE, Ret
            
            
            'Set the opacity of the layered window to 128
            SetLayeredWindowAttributes hWnd, 0, lOpacity, LWA_ALPHA
        End If
        
    End If

End Sub

Public Function WindowsIsSuitableForLayers() As Boolean

    WindowsIsSuitableForLayers = ((OSVersion And &HFF&) >= RequiredVersion)
    
End Function

